<?php
/*
 * Plugin Name: NoFollow (No, I won't let you steal my PR juice! (`_`))
 * Author: Arun S. Sekher [Physioblast, Arun]
 * Author URI: http://e107themes.net
 * Requirement: e107 v0.7.xx
 *
 * Copyright (C) 2011 Arun S. Sekher (http://e107themes.net)
 * Released under the terms and conditions of the
 * GNU General Public License (http://www.gnu.org/licenses/gpl.txt)
 *
 * $HeadURL: https://nofollow.svn.sourceforge.net/svnroot/nofollow/trunk/0.3/update-check.php $ 
 * $Revision: 15 $
 * $Date: 2011-05-08 15:54:33 +0400 (Sun, 08 May 2011) $
 * $Author: arunshekher $
 *
*/
if (!defined('e107_INIT')) { exit; }
require_once('../../class2.php');
require_once(e_ADMIN.'auth.php');
if (!getperms('P')) {
header('location:'.e_HTTP.'index.php');
exit;
}


	function show_update_msg($type, $ins_ver = '', $ver = '', $dl_url = ''){
		$message = ''; $css = '';
		//TODO: place the notice images within CSS - saves extra bit of code
		switch($type){
			case 'CXN-ERR': // connection fail CXN-ERR
				$message = APL_UPDT_CXNERR;
				$css = 'cxn-err';
				$icon = 'error.png';
				break;
			case 'UPDT-YES': // update available UPDT-YES
				$message = APL_UPDT_AVLBL.$ver;
				$css = 'upd-yes';				
				break;
			case 'UPDT-NO': // no updates UPDT-NO
				$message = APL_UPDT_NO.$ins_ver;
				$css = 'upd-no';
				$icon = 'tick-small.png';
				break;
			default:
				return false;
			}
			$msg = '<span '.($css ? 'id="'.$css.'"' : '').'>'
					.($icon ? '<img src="'.e_PLUGIN.'nofollow/img/'.$icon.'" alt="" />' : '')
					.($message ? $message : '');
			if( $type == 'UPDT-YES' && is_numeric($ver) && !empty($dl_url) && is_string($dl_url) ){
				$msg .=' <a href="'.urldecode($dl_url).'" onclick="window.open(this.href,\'_blank\');return false;">';
				$msg .='<strong>'.APL_UPDT_DL.$ver.'</strong>';
				$msg .='<img src="'.e_PLUGIN.'nofollow/img/arrow-down.png" alt="" />';
				$msg .='</a>';
			}
			$msg .= '</span>';
				
		return $msg;
	}	
	
	function check_Updates($update_url = '', $ins_ver){
		global $pref, $sql;	
		$url = 'http://sourceforge.net/api/file/index/project-id/542676/mtime/desc/rss';		
		$ver = '';
		$connection = false;
		
		if(isset($url)){	$xml = @simplexml_load_file($url);	}
		
		if(!$xml){
			$notice = show_update_msg('CXN-ERR');
		}else{	
			$title = $xml->channel->item->title;	/* $title = /nofollow_0.x.zip */
			$dl_url = $xml->channel->item->link;
			$frag = explode('_', $title);
			$ver = substr($frag[1], 0, -4);
			$connection = true;
		}
		
		/* plug_installed = current version */
		$ins_ver = $pref['plug_installed']['nofollow'];
		if($ver && is_numeric($ver)){			
			//if(bccomp($ver, $ins_ver) == 1){ // 1 update available, -1 no update availabe
			if($ver > $ins_ver){
				$notice = show_update_msg('UPDT-YES', '', $ver, $dl_url);		
				$update_flag = 1; // 1 means update available
			}else{
				$notice = show_update_msg('UPDT-NO', $ins_ver);
				$update_flag = 0; // 0 means no update
				}
		}//TODO: Add error of unknown origin where $version can't be found else{ UNKNOWN ERROR }

	if($connection){		
		/* update check time to a generic table - inspiration wordpress */
		$time = time(); // time now
		if(!is_object($sql)){ $sql = new db; }
		$update_check = $sql->db_Update("generic", "gen_datestamp = '".$time."', gen_user_id = '".$update_flag."', gen_ip = '".$ver."', gen_chardata = '".$dl_url."' WHERE gen_type = 'nofollow_update'");
		if(!$update_check){	
			$sql->db_Insert("generic", "'', 'nofollow_update', '".$time."', '".$update_flag."', '".$ver."', '', '".$dl_url."'");
			}
		}
		return $notice;
	}
		
	/* get update info conditionally */
	function get_updateInfo() {
		global $pref, $sql;
		if(!is_object($sql)){ $sql = new db; }
		$sql->db_Select("generic","gen_datestamp, gen_user_id, gen_ip, gen_chardata", "gen_type = 'nofollow_update'");
		$rs = $sql->db_Fetch(MYSQL_ASSOC);
		//print_r($rs);
		$time = time(); //time now
		$last_time = $rs['gen_datestamp']; // last checked time
		$ins_ver = $pref['plug_installed']['nofollow'];
		$new_ver = trim($rs['gen_ip']); //latest version available
		$update_flag = $rs['gen_user_id'];
		$dl_url = trim($rs['gen_chardata']);

		if($ins_ver == $new_ver && $update_flag){ // if new version already installed change the update flag in db to 0
			if(!is_object($sql)){ $sql = new db; }
			$sql->db_Update("generic", "gen_user_id = '0' WHERE gen_type = 'nofollow_update'");
			}
			
		if($time - $last_time >= 86400){ // time now - last checked time >= 24 hrs check updates agian
			$text = check_Updates();	
		}else{
			if($update_flag){
				$text = show_update_msg('UPDT-YES', '', $new_ver, $dl_url);		
			}else{
				$text = show_update_msg('UPDT-NO', $ins_ver);
				}
			}
		 return $text;
	}

?>